; GUI #
include win64a.inc
cdXPos          = 128
cdYPos          = 128
cdXSize         = 450
cdYSize         = 300
WrapModeTile = 0
SmoothingModeAntiAlias = 5
MatrixOrderPrepend = 0
MatrixOrderAppend = 1
.code
WinMain proc 
local msg:MSG
;  GDIPLUS
	invoke GdiplusStartup,&gdiplusToken,&gsi,0	
	xor ebx,ebx
	mov esi,IMAGE_BASE
	invoke	LoadCursorFromFileA,"br_Rabbit3.cur"
	mov	edi,offset ClassName
	push	rax	   ;hIconSm
	push	rdi	   ;lpszClassName
	push	rbx	   ;lpszMenuName
	push	COLOR_BTNFACE;hbrBackground
	push	rax	   ;hCursor
	push	rax        ;hIcon
	push	rsi	   ;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc   ;lpfnWndProc
      	push sizeof WNDCLASSEX;cbSize & style
	invoke	RegisterClassExA,esp	;addr WNDCLASSEX
	push	rbx
	push	rsi	   ;rsi=400000h
	push	rbx
	push	rbx
	push	cdYSize
	push	cdXSize
	push	cdYPos
	push	cdXPos
	sub	esp,20h
    	invoke	CreateWindowExA,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_VISIBLE
    	lea edi,msg
@@:   	invoke	GetMessageA,edi,NULL,0,0
	invoke	DispatchMessageA,edi
        jmp @b
WinMain endp
WndProc proc hWnd:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT     

      	mov	hWnd,rcx
      	cmp	edx,WM_DESTROY
      	je	wmDESTROY
      	cmp	edx,WM_SIZE
      	je	wmSIZE
      	cmp	edx,WM_PAINT
      	je	wmPAINT
      	cmp	edx,WM_KEYDOWN
	je	wmKEYDOWN
      	cmp	edx,WM_CREATE
	je	wmCREATE
        leave
        jmp NtdllDefWindowProc_
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	jne	wmBYE
wmDESTROY:invoke GdipDisposeImage,hBitmap
	invoke	GdipDeleteGraphics,memGraphics
;  GDI+
	mov	ecx,gdiplusToken
	invoke	GdiplusShutdown
	invoke	RtlExitUserProcess,NULL
;------------------------------------------------------------
wmPAINT:invoke	BeginPaint,hWnd, &ps
	invoke	GdipCreateFromHDC,eax, &graphics
	invoke	GdipSetSmoothingMode,graphics, SmoothingModeAntiAlias;    
	movd xmm1,const112
	invoke	GdipRotateWorldTransform,graphics,,MatrixOrderAppend
	cvtsi2ss xmm1,vdxClient
	divss	xmm1,const2; (float)vdxClient/2.0
	cvtsi2ss xmm2,vdyClient
	divss	xmm2,const2;(float)vdyClient/2.0
	invoke	GdipTranslateWorldTransform,graphics,,,MatrixOrderAppend

	invoke	GdipDrawImageI,graphics, smBitmap,0, 0
	invoke	GdipResetWorldTransform,graphics

	invoke	GdipDeleteGraphics,graphics
	invoke	EndPaint,hWnd, &ps
	jmp	wmBYE
wmCREATE:invoke GdipCreateFromHWND,hWnd, &graphics
	invoke	GdipLoadImageFromFile,&FileName, &hBitmap
	invoke	GdipCreateBitmapFromGraphics,130, 130, graphics, &smBitmap
	invoke	GdipGetImageWidth,hBitmap, &nWidth
	invoke	GdipGetImageHeight,hBitmap, &nHeight
	invoke	GdipGetImageGraphicsContext,smBitmap, &memGraphics
	mov	qword ptr[rsp+28h],122;40 ; x-size
	mov	qword ptr[rsp+20h],130 ; y-size
	invoke	GdipDrawImageRectI,memGraphics, hBitmap, 0, 0; x, y   ,   
	invoke	GdipDeleteGraphics,graphics
	jmp	wmBYE
wmSIZE: mov	vdxClient,r9d
	and	vdxClient,0FFFFh;vdxClient = LOWORD (lParam) ;
        shr	r9d,16
	mov	vdyClient,r9d; vdyClient = HIWORD (lParam) ;
	invoke	InvalidateRect,hWnd, NULL,TRUE
wmBYE:  leave
        ret
WndProc endp
;---------------------------------------
.data
ClassName db '    GDI+',0
gsi GdiplusStartupInput <1,0,0,0,0>
FileName:	du <Comecocos.png>
const2		dd 2.0
const112	dd 112.0
.data?
gdiplusToken	dd ? ;
memGraphics	dq ?
hBitmap		dq ?
vdxClient	dd ? ;
vdyClient	dd ? ;
nWidth		dq ?
nHeight		dq ?
smBitmap	dq ?
graphics	dq ?
end